/* Webolize IssueTracker and Webolize Core
 * Copyright (C) 2007 Webolize LLC
 * http://www.webolize.com
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Webolize.IssueTracker.Domain;

using Cuyahoga.Core.Util;
using Cuyahoga.Web.UI;

namespace Webolize.IssueTracker.Web.Admin
{
	/// <summary>
	/// Summary description for Edit Forums.
	/// </summary>
    public class EditStatusType : ModuleAdminBasePage
	{
        protected System.Web.UI.WebControls.TextBox wf_Name;
        protected System.Web.UI.WebControls.TextBox wf_Value;
        protected System.Web.UI.WebControls.CheckBox wf_Active;
        protected System.Web.UI.WebControls.LinkButton wf_Submit;
        protected System.Web.UI.WebControls.Label wf_Status;

		private IssueTrackerModule _module;
        private int statusTypeID;

		private void Page_Load(object sender, System.EventArgs e)
		{
			base.Title = "Webolize IssueTracker Administration";
			this._module = base.Module as IssueTrackerModule;

            if ( Request.QueryString["StatusTypeId"] != null ) {
                statusTypeID = Int32.Parse( Request.QueryString["StatusTypeId"] );
            } else {
                statusTypeID = -1;
            }

			if (! this.IsPostBack)
			{
                BindData();
			}
		}

        private void BindData()
        {
            IssueTrackerDB itdb = new IssueTrackerDB( _module.SessMgr );

            if ( statusTypeID >= 0 ) {
                ITAttribute itstat = itdb.GetSingleAttribute( statusTypeID );

                wf_Name.Text = itstat.Name;
                wf_Value.Text = itstat.Value;
                wf_Active.Checked = itstat.Active;

                wf_Status.Visible = false;
            } else {
                wf_Active.Checked = true;

                wf_Submit.Text = "create status type";
            }
        }


        protected void wf_Submit_Click( object sender, EventArgs e )
        {
            Cuyahoga.Core.Domain.User _currentUser = Context.User.Identity as Cuyahoga.Core.Domain.User;
            IssueTrackerDB itdb = new IssueTrackerDB( _module.SessMgr );
            ITAttribute st;

            if ( statusTypeID >= 0 ) {
                st = itdb.GetSingleAttribute( statusTypeID );
            } else {
                st = new ITAttribute();
            }

            st.Name = wf_Name.Text;
            st.Value = wf_Value.Text;
            st.Active = wf_Active.Checked;
            st.CreatedByID = _currentUser.Id;
            st.CreatedDate = DateTime.Now;

            // constants
            st.Application = "Webolize-IssueTracker";
            st.AttributeType = "STATUS";

            // Save or update StatusType
            if ( statusTypeID >= 0 ) {
                itdb.Update( st );
                wf_Status.Text = "status type has been updated";
                wf_Status.Visible = true;
            } else {
                itdb.SaveAttribute( st );
                wf_Status.Text = "status type has been created";
                wf_Status.Visible = true;
            }
        }

        protected void wf_Back_Click( object sender, EventArgs e )
        {
            Response.Redirect( String.Format("~/Modules/Webolize-IssueTracker/Admin/Admin.aspx?NodeId={0}&SectionId={1}", this.Node.Id, this.Section.Id ) );
        }

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
